// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QWEBENGINEURLREQUESTINTERCEPTORWRAPPER_H
#define SBK_QWEBENGINEURLREQUESTINTERCEPTORWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWebEngineCore/qwebengineurlrequestinterceptor.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QWebEngineUrlRequestInterceptorWrapper : public QWebEngineUrlRequestInterceptor
{
public:
    QWebEngineUrlRequestInterceptorWrapper(::QObject * p = nullptr);
    QWebEngineUrlRequestInterceptorWrapper(const QWebEngineUrlRequestInterceptorWrapper &) = delete;
    QWebEngineUrlRequestInterceptorWrapper& operator=(const QWebEngineUrlRequestInterceptorWrapper &) = delete;
    QWebEngineUrlRequestInterceptorWrapper(QWebEngineUrlRequestInterceptorWrapper &&) = delete;
    QWebEngineUrlRequestInterceptorWrapper& operator=(QWebEngineUrlRequestInterceptorWrapper &&) = delete;
    ~QWebEngineUrlRequestInterceptorWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void interceptRequest(::QWebEngineUrlRequestInfo & info) override;
    static void sbk_o_interceptRequest(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QWebEngineUrlRequestInfo & info);
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QWEBENGINEURLREQUESTINTERCEPTORWRAPPER_H
